;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    ordinamento vettore numeri     ;
;          con bubble sort          ;
; in e out seriale, memoria esterna, conversione stringhe-numeri, algoritmo piu' complesso, stack
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CSEG AT 0H 

;;;;;;;;;;;;; main ;;;;;;;;;;;;;;;;
; inizializzo la seriale
ORL TMOD, #20H
SETB TR1
MOV SCON, #50H
MOV TH1, #230 ; 2400 baud
ORL PCON, #80H

SETB TI

MOV DPTR, #input
CALL puts
CALL getnum ; numero di elementi
MOV A, R1

CALL chiediamoli

CALL bubblesort 

PUSH ACC

MOV DPTR, #incorder
CALL puts

POP ACC

CALL vediamoli

JMP $

;;;;;;;;;;;;; ORDINO ;;;;;;;;;;;;;;;
;; con bubble sort
;; O(n2)
bubblesort:
MOV R5, A
MOV R6, A
PUSH ACC ; salvo il numero di elementi
reinizio:
MOV B, R5
MOV R7, B

MOV DPTR, #vectbuff ; ripristino l'indirizzo d'inizio del vettore

ciclo:
MOVX A, @DPTR
MOV R2, A
INC DPTR
MOVX A, @DPTR
MOV R3, A

SUBB A, R2
JBC PSW.7, eminore ; c'e' carry, quindi il risultato e' negativo
MOV A, R3
MOV B, R2
SJMP emaggiore
eminore:
MOV A, R2
MOV B, R3
emaggiore:
MOVX @DPTR, A

DEC DPL ; agisco su meno di 255 

MOV A, B
MOVX @DPTR, A

INC DPTR ; la coppia successiva

DEC R7
CJNE R7, #1, ciclo
DJNZ R6, reinizio

POP ACC
RET

;;;;;;;;; chiedo gli elementi ;;;;;;;;;;
chiediamoli:
MOV R7, A ; R7 contatore
PUSH ACC

MOV DPTR, #vectbuff ; per il vettore

unaltro:
MOV R0, DPL
PUSH DPL
PUSH DPH

MOV DPTR, #elemento
CALL puts
MOV A, R0
SUBB A, #vectbuff ; senno' parte dall'indirizzo
INC A ; gli umani partono da uno
CALL putbignum
MOV DPTR, #duepunti
CALL puts

CALL getnum ; numero da memorizzare
MOV A, R1

POP DPH
POP DPL

MOVX @DPTR, A ; indirizzamento ESTERNO diretto

INC DPTR

DJNZ R7, unaltro ; chiede un altro numero in input

POP ACC ; ripristino A che contiene il numero di elementi
RET

;;;;;;;;;;;;; vedo gli elementi ;;;;;;;;;;;;
vediamoli:
MOV R7, A ; numero elementi

MOV DPTR, #vectbuff ; per il vettore

vedo:

MOV R0, DPL

PUSH DPL
PUSH DPH

MOV DPTR, #elemento
CALL puts
MOV A, R0
SUBB A, #vectbuff ; senno' parte dall'indirizzo (2)
INC A ; parto da uno
CALL putbignum
MOV DPTR, #duepunti
CALL puts

POP DPH
POP DPL

MOVX A, @DPTR ; indirizzamento ESTERNO diretto
CALL putbignum

INC DPTR

DJNZ R7, vedo ; li listo tutti
RET

;;;;;;;;;;;; output str ;;;;;;;;;;;;;
putc:
JNB TI, putc
CLR TI
MOV SBUF, A
RET

puts:
CLR A
MOVC A, @A+DPTR
JNZ more
RET

more:
CALL putc
INC DPTR
JMP puts

;; vuole in A il numero, modifica anche B
putbignum:
JNB TI, putbignum
CLR TI

MOV B, #10
DIV AB

ADD A, #'0'
MOV SBUF, A

wait:
JNB TI, wait
CLR TI

MOV A, B
ADD A, #'0'
MOV SBUF, A

RET

;;;;;;;;;;;;; input ;;;;;;;;;;;;;;;;
getnum:
JNB RI, $ ; aspetto sia disponibile seriale
MOV A, SBUF ; leggo il char
CLR RI
CALL PUTC ; l'echo

SUBB A, #'0' ; diventa numero
MOV R1, A ; metto il numero in R1

JNB RI, $ ; seconda cifra (se e' una ...)
MOV A, SBUF ; leggo il char
CLR RI
CALL PUTC ; l'echo

cjne A, #CR, NoCr ; e' un CR oppure un numero?
SJMP fine ; e' un CR, ho finito

NoCr:
SUBB A, #'0' ; diventa numero
MOV R2, A ; quindi sono le unita'
MOV A, R1
MOV B, #10
MUL AB

ADD A, R2 ; sommo decine ed unita', in A risultato
MOV R1, A
fine:
RET

;;;;;;;;;;; code data ;;;;;;;;;;;;;
CR EQU 0DH
LF EQU 0AH

input: DB 'number of element (max 99, each max 99): ', 0
elemento: DB CR, LF, 'element ', 0
duepunti: DB ' : ', 0
acapo: DB CR, LF, 0
incorder: DB CR, LF, 'increasing order: ', 0

vectbuff EQU 0

END


