;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      ordinamento vettore numeri      ;
;          con bubble e count          ;
; in e out seriale, memoria interna, memoria esterna (diretto e indiretto (count)) 
; (dpl, dph) (con due puntatori), conversione stringhe-numeri, algoritmo complesso,
; operazioni matematiche 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CSEG AT 0H 

;;;;;;;;;;;;; main ;;;;;;;;;;;;;;;;
ORL TMOD, #20H
SETB TR1
MOV SCON, #50H
MOV TH1, #230 ; 2400 baud
ORL PCON, #80H

SETB TI

MOV DPTR, #input
CALL puts
CALL getnum
MOV A, R1
PUSH ACC

CALL chiediamoli

MOV DPTR, #algo
CALL puts
MOV DPTR, #bubble
CALL puts
MOV DPTR, #counting
CALL puts
CALL getc
POP ACC

CJNE R1, #'b', algo_count
CALL bubblesort
JMP algo_end

algo_count:
CALL countsort
algo_end:

CALL vediamoli

JMP $

;;;;;; countsort ;;;;;;
countsort:
PUSH ACC ; salvo il numero di elementi
MOV R6, A

MOV A, #0
MOV DPTR, #presenze
cleanp:
MOVX @DPTR, A
INC DPTR
MOV R0, DPL
CJNE R0, #finepresenze, cleanp

;;
MOV DPTR, #vectbuff
costruisco:
MOVX A, @DPTR
PUSH DPL
PUSH DPH

MOV DPTR, #presenze
ADD A, #presenze
MOV DPL, A

MOVX A, @DPTR
INC A
MOVX @DPTR, A

POP DPH
POP DPL
INC DPTR
DJNZ R6, costruisco

;;
MOV R0, #0
MOV DPTR, #presenze
MOV R2, #vectbuff
aggiorno:
MOVX A, @DPTR ; numero di elementi di valore R0

CJNE A, #0, conto
SJMP nonconto

conto:
MOV R1, A
PUSH DPL
PUSH DPH

sottociclo:
MOV DPTR, #vectbuff
MOV DPL, R2
MOV A, R0
MOVX @DPTR, A

INC R2
DJNZ R1, sottociclo

POP DPH
POP DPL
nonconto:

INC DPTR
INC R0
CJNE R0, #99, aggiorno ; 99 presenze

POP ACC
RET

;;;;;;;;;;;;; ORDINO ;;;;;;;;;;;;;;;
;; con bubble sort
;; O(n2)
bubblesort:
MOV R5, A
MOV R6, A
PUSH ACC ; salvo il numero di elementi
reinizio:
MOV B, R5
MOV R7, B

MOV DPTR, #vectbuff ; ripristino l'indirizzo d'inizio del vettore

ciclo:
MOVX A, @DPTR
MOV R2, A
INC DPTR
MOVX A, @DPTR
MOV R3, A

SUBB A, R2
JBC PSW.7, eminore ; c'e' carry, quindi il risultato e' negativo
MOV A, R3
MOV B, R2
SJMP emaggiore
eminore:
MOV A, R2
MOV B, R3
emaggiore:
MOVX @DPTR, A

DEC DPL ; agisco su meno di 255 

MOV A, B
MOVX @DPTR, A

INC DPTR ; la coppia successiva

DEC R7
CJNE R7, #1, ciclo
DJNZ R6, reinizio

POP ACC
RET

;;;;;;;;; chiedo gli elementi ;;;;;;;;;;
chiediamoli:
MOV R7, A ; R7 contatore
PUSH ACC

MOV DPTR, #vectbuff ; per il vettore

unaltro:
MOV R0, DPL
PUSH DPL
PUSH DPH

MOV DPTR, #elemento
CALL puts
MOV A, R0
SUBB A, #vectbuff 
INC A ; parto da uno
CALL putbignum
MOV DPTR, #duepunti
CALL puts

CALL getnum ; numero da memorizzare
MOV A, R1

POP DPH
POP DPL

MOVX @DPTR, A 
INC DPTR

DJNZ R7, unaltro 

POP ACC 
RET

;;;;;;;;;;;;; vedo gli elementi ;;;;;;;;;;;;
vediamoli:
MOV R7, A ; numero elementi
MOV DPTR, #vectbuff ; per il vettore

vedo:

MOV R0, DPL

PUSH DPL
PUSH DPH

MOV DPTR, #elemento
CALL puts
MOV A, R0
SUBB A, #vectbuff
INC A ; parto da uno
CALL putbignum
MOV DPTR, #duepunti
CALL puts

POP DPH
POP DPL

MOVX A, @DPTR
CALL putbignum

INC DPTR

DJNZ R7, vedo
RET

;;;;;;;;;;;; output str ;;;;;;;;;;;;;
putc:
JNB TI, putc
CLR TI
MOV SBUF, A
RET

puts:
CLR A
MOVC A, @A+DPTR
JNZ more
RET

more:
CALL putc
INC DPTR
JMP puts

;; vuole in A il numero, modifica anche B
putbignum:
JNB TI, putbignum
CLR TI

MOV B, #10
DIV AB

ADD A, #'0'
MOV SBUF, A

wait:
JNB TI, wait
CLR TI

MOV A, B
ADD A, #'0'
MOV SBUF, A

RET

;;;;;;;;;;;;; input ;;;;;;;;;;;;;;;;
getnum:
JNB RI, $ ; aspetto sia disponibile seriale
MOV A, SBUF ; leggo il char
CLR RI
CALL PUTC ; l'echo

SUBB A, #'0' ; diventa numero
MOV R1, A ; metto il numero in R1

JNB RI, $ ; seconda cifra (se e' una ...)
MOV A, SBUF ; leggo il char
CLR RI
CALL PUTC ; l'echo

cjne A, #CR, NoCr ; e' un CR oppure un numero?
SJMP fine ; e' un CR, ho finito

NoCr:
SUBB A, #'0' ; diventa numero
MOV R2, A ; quindi sono le unita'
MOV A, R1
MOV B, #10
MUL AB

ADD A, R2 ; sommo decine ed unita', in A risultato
MOV R1, A
fine:
RET

;;;;;
getc: 
JNB RI, $
MOV A, SBUF ; leggo il char
CLR RI
CALL PUTC
MOV R1, A
RET

;;;;;;;;;;; code data ;;;;;;;;;;;;;
CR EQU 0DH
LF EQU 0AH

input: DB 'number of element (max 99, each max 99): ', 0
elemento: DB CR, LF, 'element ', 0
duepunti: DB ' : ', 0
acapo: DB CR, LF, 0
algo: DB CR, LF, 'what algorithm you choose? ', CR, LF, 0
bubble: DB 'with [b]ubble sorting (less memory, O(n2)) ', CR, LF, 0
counting: DB 'with [c]ount sorting (more memory, O(3n), default) ', CR, LF, 0

vectbuff EQU 0
presenze EQU 100 ; per il countsort
finepresenze EQU 199 ; per il countsort

END


